create or replace package UDO_PKG_EQUIPDS as

  /*  "  " */
  procedure LIST
  (
    COUT                    out clob    --     
  );

  /*   "  " */
  procedure INS
  (
    SCODE                   in varchar2, -- 
    SNAME                   in varchar2, -- 
    NRN                     out number   --  
  );
  
  /*   "  " */
  procedure DEL
  (
    NRN                     in number   --  
  );
  
  /*  "   ( )" */
  procedure CM_CARD
  (
    NEQUIPDSCM              in number,  -- .     
    COUT                    out clob    --    
  );
  
  /*  "   ( )" */
  procedure CM_LIST
  (
    NEQUIPDS                in number,  -- .   
    COUT                    out clob    --  
  );
  
  /*   "   ( )" */
  procedure CM_INS
  (
    NPRN                    in number,   -- 
    SEQOBJKIND              in varchar2, --  
    SUSERPROCS_DATA         in varchar2, --  
    SEXSSERVICE_UPLOAD      in varchar2, --     
    SEXSSERVICEFN_UPLOAD    in varchar2, --     
    SEXSSERVICE_SEND_MD     in varchar2, --      
    SEXSSERVICEFN_SEND_MD   in varchar2, --      
    SEXSSERVICE_SEND_RQ     in varchar2, --      
    SEXSSERVICEFN_SEND_RQ   in varchar2, --      
    NRN                     out number   --  
  );
  
  /*   "   ( )" */
  procedure CM_DEL
  (
    NRN                     in number   --  
  );
  
  /*  "   ( ,  )" */
  procedure CMFL_LIST
  (
    NEQUIPDSCM              in number,  -- .     
    COUT                    out clob    --     
  );

  /*    "   ( ,  )" */
  procedure CMFL_UPLOAD
  (
    NEQUIPDSCM              in number   -- .     
  );

  /*    "   ( ,  )" */
  procedure CMFL_SEND_MD
  (
    NEQUIPDSCM              in number   -- .     
  );

  /*  "   ( , )" */
  procedure CMML_LIST
  (
    NEQUIPDSCM              in number,  -- .     
    COUT                    out clob    --     
  );
  
  /*   "   ( , )" */
  procedure CMML_INS
  (
    NPRN                    in number,   -- 
    STASK                   in varchar2, --  (TCF -    (Technical Condition Forecast), RUL -    (Remaining Useful Life), FP -   (Failure Predict))
    NPRECISION_P            in number,   --  ()
    NRN                     out number   --  
  );
  
  /*   "   ( , )" */
  procedure CMML_DEL
  (
    NRN                     in number   --  
  );
  
  /*    "   ( , )" */
  procedure CMML_SEND_RQ
  (
    NEQUIPDSCMML            in number   -- .      
  );
  
  /*  "   ( , )"    */
  function CMML_STATUS_BY_EQCONFIG
  (
    NEQCONFIG               in number   -- .    
  ) return                  number;     --     (0 -  , 1 -     , 2 -   )

  /*  "   ( , )"    */
  procedure CMML_LIST_BY_EQCONFIG
  (
    NEQCONFIG               in number,  -- .    
    COUT                    out clob    --       
  );

  /*  - */
  procedure CMMLH_DEMO_BUILD
  (
    STASK                   in varchar2, -- 
    COUT                    out clob     --  -
  );
  
  /*  "   ( , ,  )"    */
  procedure CMMLH_LIST_BY_EQCONFIG
  (
    NEQCONFIG               in number,  -- .    
    COUT                    out clob    --       
  );

end UDO_PKG_EQUIPDS;
/
create or replace package body UDO_PKG_EQUIPDS as

/*
TODO: owner="root" created="06.08.2024"
text="      "" """
*/

  /*  "  " */
  procedure LIST
  (
    COUT                    out clob                               --     
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); --  
    NCUR                    integer;                               --    
    XDOC                    PKG_XMAKE.TNODE;                       --   
    XDS                     PKG_XMAKE.TNODE;                       --    
  begin
    /*   */
    NCUR := PKG_XMAKE.OPEN_CURSOR();
    /*    */
    for C in (select T.RN   NRN,
                     T.NAME SNAME
                from UDO_T_EQUIPDS T
               where T.COMPANY = NCOMPANY
               order by T.NAME)
    loop
      XDS := PKG_XMAKE.CONCAT(ICURSOR => NCUR,
                              RNODE00 => XDS,
                              RNODE01 => PKG_XMAKE.ELEMENT(ICURSOR     => NCUR,
                                                           SNAME       => 'XDS',
                                                           RATTRIBUTES => PKG_XMAKE.ATTRIBUTES(ICURSOR      => NCUR,
                                                                                               RATTRIBUTE00 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                                                   SNAME   => 'NRN',
                                                                                                                                   SVALUE  => C.NRN),
                                                                                               RATTRIBUTE01 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                                                   SNAME   => 'SNAME',
                                                                                                                                   SVALUE  => C.SNAME))));
    end loop;
    /*  XML-  */
    XDOC := PKG_XMAKE.ELEMENT(ICURSOR => NCUR, SNAME => 'XDATA', RNODE00 => XDS);
    /*   CLOB */
    COUT := PKG_XMAKE.SERIALIZE_TO_CLOB(ICURSOR => NCUR,
                                        ITYPE   => PKG_XMAKE.CONTENT_,
                                        RNODE   => XDOC,
                                        RHEADER => PKG_XHEADER.WRAP_ALL(SVERSION    => PKG_XHEADER.VERSION_1_0_,
                                                                        SENCODING   => PKG_XHEADER.ENCODING_UTF_,
                                                                        SSTANDALONE => PKG_XHEADER.STANDALONE_YES_));
    /*   */
    PKG_XMAKE.CLOSE_CURSOR(ICURSOR => NCUR);
  end LIST;
  
  /*   "  " */
  procedure INS
  (
    SCODE                   in varchar2,                           -- 
    SNAME                   in varchar2,                           -- 
    NRN                     out number                             --  
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- 
  begin
    /*   */
    UDO_PKG_EQUIPDS_BASE.INS(NCOMPANY => NCOMPANY, SCODE => SCODE, SNAME => SNAME, NRN => NRN);
  end INS;

  /*   "  " */
  procedure DEL
  (
    NRN                     in number                              --  
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- 
  begin
    /*   */
    UDO_PKG_EQUIPDS_BASE.DEL(NRN => NRN, NCOMPANY => NCOMPANY);
  end DEL;
  
  /*  "   ( )" */
  procedure CM_CARD
  (
    NEQUIPDSCM              in number,       -- .     
    COUT                    out clob         --  
  )
  is  
    NCUR                    integer;         --    
    XDOC                    PKG_XMAKE.TNODE; --   
    XEQUIPDSCM              PKG_XMAKE.TNODE; --   
  begin
    /*   */
    NCUR := PKG_XMAKE.OPEN_CURSOR();
    /*      */
    for C in (select T.RN NRN,
                     OK.NAME SNAME,
                     UP.CODE SUSERPROCS_DATA,
                     SU.CODE || '/' || SFU.CODE SEXSSERVICE_UPLOAD,
                     SMD.CODE || '/' || SFMD.CODE SEXSSERVICE_SEND_MD,
                     SRQ.CODE || '/' || SFRQ.CODE SEXSSERVICE_SEND_RQ
                from UDO_T_EQUIPDSCM T,
                     EQOBJKIND       OK,
                     USERPROCS       UP,
                     EXSSERVICE      SU,
                     EXSSERVICEFN    SFU,
                     EXSSERVICE      SMD,
                     EXSSERVICEFN    SFMD,
                     EXSSERVICE      SRQ,
                     EXSSERVICEFN    SFRQ
               where T.RN = NEQUIPDSCM
                 and T.EQOBJKIND = OK.RN
                 and T.USERPROCS_DATA = UP.RN
                 and T.EXSSERVICEFN_UPLOAD = SFU.RN
                 and SFU.PRN = SU.RN
                 and T.EXSSERVICEFN_SEND_MD = SFMD.RN
                 and SFMD.PRN = SMD.RN
                 and T.EXSSERVICEFN_SEND_RQ = SFRQ.RN
                 and SFRQ.PRN = SRQ.RN)
    loop
      /*     */
      XEQUIPDSCM := PKG_XMAKE.ELEMENT(ICURSOR     => NCUR,
                                      SNAME       => 'XEQUIPDSCM',
                                      RATTRIBUTES => PKG_XMAKE.ATTRIBUTES(ICURSOR      => NCUR,
                                                                          RATTRIBUTE00 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                              SNAME   => 'NRN',
                                                                                                              SVALUE  => C.NRN),
                                                                          RATTRIBUTE01 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                              SNAME   => 'SNAME',
                                                                                                              SVALUE  => C.SNAME),
                                                                          RATTRIBUTE02 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                              SNAME   => 'SUSERPROCS_DATA',
                                                                                                              SVALUE  => C.SUSERPROCS_DATA),
                                                                          RATTRIBUTE03 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                              SNAME   => 'SEXSSERVICE_UPLOAD',
                                                                                                              SVALUE  => C.SEXSSERVICE_UPLOAD),
                                                                          RATTRIBUTE04 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                              SNAME   => 'SEXSSERVICE_SEND_MD',
                                                                                                              SVALUE  => C.SEXSSERVICE_SEND_MD),
                                                                          RATTRIBUTE05 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                              SNAME   => 'SEXSSERVICE_SEND_RQ',
                                                                                                              SVALUE  => C.SEXSSERVICE_SEND_RQ)));
    end loop;
    /*  XML-  */
    XDOC := PKG_XMAKE.ELEMENT(ICURSOR => NCUR, SNAME => 'XDATA', RNODE00 => XEQUIPDSCM);
    /*   CLOB */
    COUT := PKG_XMAKE.SERIALIZE_TO_CLOB(ICURSOR => NCUR,
                                        ITYPE   => PKG_XMAKE.CONTENT_,
                                        RNODE   => XDOC,
                                        RHEADER => PKG_XHEADER.WRAP_ALL(SVERSION    => PKG_XHEADER.VERSION_1_0_,
                                                                        SENCODING   => PKG_XHEADER.ENCODING_UTF_,
                                                                        SSTANDALONE => PKG_XHEADER.STANDALONE_YES_));
    /*   */
    PKG_XMAKE.CLOSE_CURSOR(ICURSOR => NCUR);
  end CM_CARD;
  
  /*  "   ( )" */
  procedure CM_LIST
  (
    NEQUIPDS                in number,       -- .   
    COUT                    out clob         --  
  )
  is  
    NCUR                    integer;         --    
    XDOC                    PKG_XMAKE.TNODE; --   
    XDSCM                   PKG_XMAKE.TNODE; --    
  begin
    /*   */
    NCUR := PKG_XMAKE.OPEN_CURSOR();
    /*       */
    for C in (select T.RN    NRN,
                     OK.CODE SCODE,
                     OK.NAME SNAME
                from UDO_T_EQUIPDSCM T,
                     EQOBJKIND       OK
               where T.PRN = NEQUIPDS
                 and T.EQOBJKIND = OK.RN
               order by OK.CODE)
    loop
      XDSCM := PKG_XMAKE.CONCAT(ICURSOR => NCUR,
                                RNODE00 => XDSCM,
                                RNODE01 => PKG_XMAKE.ELEMENT(ICURSOR     => NCUR,
                                                             SNAME       => 'XDSCM',
                                                             RATTRIBUTES => PKG_XMAKE.ATTRIBUTES(ICURSOR      => NCUR,
                                                                                                 RATTRIBUTE00 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                                                     SNAME   => 'NRN',
                                                                                                                                     SVALUE  => C.NRN),
                                                                                                 RATTRIBUTE01 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                                                     SNAME   => 'SCODE',
                                                                                                                                     SVALUE  => C.SCODE),
                                                                                                 RATTRIBUTE02 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                                                     SNAME   => 'SNAME',
                                                                                                                                     SVALUE  => C.SNAME))));
    end loop;
    /*  XML-  */
    XDOC := PKG_XMAKE.ELEMENT(ICURSOR => NCUR, SNAME => 'XDATA', RNODE00 => XDSCM);
    /*   CLOB */
    COUT := PKG_XMAKE.SERIALIZE_TO_CLOB(ICURSOR => NCUR,
                                        ITYPE   => PKG_XMAKE.CONTENT_,
                                        RNODE   => XDOC,
                                        RHEADER => PKG_XHEADER.WRAP_ALL(SVERSION    => PKG_XHEADER.VERSION_1_0_,
                                                                        SENCODING   => PKG_XHEADER.ENCODING_UTF_,
                                                                        SSTANDALONE => PKG_XHEADER.STANDALONE_YES_));
    /*   */
    PKG_XMAKE.CLOSE_CURSOR(ICURSOR => NCUR);
  end CM_LIST;
  
  /*   "   ( )" */
  procedure CM_INS
  (
    NPRN                    in number,                             -- 
    SEQOBJKIND              in varchar2,                           --  
    SUSERPROCS_DATA         in varchar2,                           --  
    SEXSSERVICE_UPLOAD      in varchar2,                           --     
    SEXSSERVICEFN_UPLOAD    in varchar2,                           --     
    SEXSSERVICE_SEND_MD     in varchar2,                           --      
    SEXSSERVICEFN_SEND_MD   in varchar2,                           --      
    SEXSSERVICE_SEND_RQ     in varchar2,                           --      
    SEXSSERVICEFN_SEND_RQ   in varchar2,                           --      
    NRN                     out number                             --  
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- 
    NEQOBJKIND              PKG_STD.TREF;                          -- .   
    NUSERPROCS_DATA         PKG_STD.TREF;                          -- .   
    NEXSSERVICEFN_UPLOAD    PKG_STD.TREF;                          -- .      
    NEXSSERVICEFN_SEND_MD   PKG_STD.TREF;                          -- .       
    NEXSSERVICEFN_SEND_RQ   PKG_STD.TREF;                          -- .       
  begin
    /*   */
    UDO_PKG_EQUIPDS_BASE.CM_JOINS(NCOMPANY              => NCOMPANY,
                                  SEQOBJKIND            => SEQOBJKIND,
                                  SUSERPROCS_DATA       => SUSERPROCS_DATA,
                                  SEXSSERVICE_UPLOAD    => SEXSSERVICE_UPLOAD,
                                  SEXSSERVICEFN_UPLOAD  => SEXSSERVICEFN_UPLOAD,
                                  SEXSSERVICE_SEND_MD   => SEXSSERVICE_SEND_MD,
                                  SEXSSERVICEFN_SEND_MD => SEXSSERVICEFN_SEND_MD,
                                  SEXSSERVICE_SEND_RQ   => SEXSSERVICE_SEND_RQ,
                                  SEXSSERVICEFN_SEND_RQ => SEXSSERVICEFN_SEND_RQ,
                                  NEQOBJKIND            => NEQOBJKIND,
                                  NUSERPROCS_DATA       => NUSERPROCS_DATA,
                                  NEXSSERVICEFN_UPLOAD  => NEXSSERVICEFN_UPLOAD,
                                  NEXSSERVICEFN_SEND_MD => NEXSSERVICEFN_SEND_MD,
                                  NEXSSERVICEFN_SEND_RQ => NEXSSERVICEFN_SEND_RQ);
    /*   */
    UDO_PKG_EQUIPDS_BASE.CM_INS(NPRN                  => NPRN,
                                NEQOBJKIND            => NEQOBJKIND,
                                NUSERPROCS_DATA       => NUSERPROCS_DATA,
                                NEXSSERVICEFN_UPLOAD  => NEXSSERVICEFN_UPLOAD,
                                NEXSSERVICEFN_SEND_MD => NEXSSERVICEFN_SEND_MD,
                                NEXSSERVICEFN_SEND_RQ => NEXSSERVICEFN_SEND_RQ,
                                NRN                   => NRN);
  end CM_INS;

  /*   "   ( )" */
  procedure CM_DEL
  (
    NRN                     in number   --  
  )
  is
  begin
    /*   */
    UDO_PKG_EQUIPDS_BASE.CM_DEL(NRN => NRN);
  end CM_DEL;  
  
  /*  "   ( ,  )" */
  procedure CMFL_LIST
  (
    NEQUIPDSCM              in number,                      -- .     
    COUT                    out clob                        --     
  )
  is
    RDG                     PKG_P8PANELS_VISUAL.TDATA_GRID; --  
    RDG_ROW                 PKG_P8PANELS_VISUAL.TROW;       --  
  begin
    /*    */
    RDG := PKG_P8PANELS_VISUAL.TDATA_GRID_MAKE();
    /*      */
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NRN',
                                               SCAPTION   => '. ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SFILE_NAME',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SDESCR',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NSTATUS',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SERR',
                                               SCAPTION   => '  ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    /*   */
    for C in (select T.RN        NRN,
                     T.FILE_NAME SFILE_NAME,
                     T.DESCR     SDESCR,
                     T.STATUS    NSTATUS,
                     T.ERR       SERR
                from UDO_T_EQUIPDSCMFL T
               where T.PRN = NEQUIPDSCM
               order by T.RN)
    loop
      /*     */
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NRN', NVALUE => C.NRN, BCLEAR => true);
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SFILE_NAME', SVALUE => C.SFILE_NAME);
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SDESCR', SVALUE => C.SDESCR);
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NSTATUS', NVALUE => C.NSTATUS);
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SERR', SVALUE => C.SERR);
      /*     */
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW);
    end loop;
    /*   */
    COUT := PKG_P8PANELS_VISUAL.TDATA_GRID_TO_XML(RDATA_GRID => RDG, NINCLUDE_DEF => 1);
  end CMFL_LIST;
  
  /*    "   ( ,  )" */
  procedure CMFL_UPLOAD
  (
    NEQUIPDSCM              in number   -- .     
  )
  is
  begin
    /*
    TODO: owner="root" created="07.08.2024"
    text="       "
    */
    /*       */
    for C in (select T.RN NRN from UDO_T_EQUIPDSCMFL T where T.PRN = NEQUIPDSCM)
    loop
      UDO_PKG_EQUIPDS_BASE.CMFL_SET_STATUS(NRN => C.NRN, NSTATUS => 2, SQUEUE_ID => C.NRN, SERR => null);
    end loop;
  end CMFL_UPLOAD;
  
  /*    "   ( ,  )" */
  procedure CMFL_SEND_MD
  (
    NEQUIPDSCM              in number   -- .     
  )
  is
  begin
    /*
    TODO: owner="root" created="07.08.2024"
    text="       "
    */
    /*       */
    for C in (select T.RN NRN from UDO_T_EQUIPDSCMFL T where T.PRN = NEQUIPDSCM)
    loop
      UDO_PKG_EQUIPDS_BASE.CMFL_SET_STATUS(NRN => C.NRN, NSTATUS => 5, SQUEUE_ID => C.NRN, SERR => null);
    end loop;
  end CMFL_SEND_MD;
  
  /*  "   ( , )" */
  procedure CMML_LIST
  (
    NEQUIPDSCM              in number,                      -- .     
    COUT                    out clob                        --     
  )
  is
    RDG                     PKG_P8PANELS_VISUAL.TDATA_GRID; --  
    RDG_ROW                 PKG_P8PANELS_VISUAL.TROW;       --  
  begin
    /*    */
    RDG := PKG_P8PANELS_VISUAL.TDATA_GRID_MAKE();
    /*      */
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NRN',
                                               SCAPTION   => '. ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'STASK',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               SHINT      => '  :<br>' || UDO_PKG_EQUIPDS_BASE.CMML_TASK_HINT());
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NPRECISION_P',
                                               SCAPTION   => ' ()',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NPRECISION_F',
                                               SCAPTION   => ' ()',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NSTATUS',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SERR',
                                               SCAPTION   => '  ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SACTIONS',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR);
    /*   */
    for C in (select T.RN          NRN,
                     T.TASK        STASK,
                     T.PRECISION_P NPRECISION_P,
                     T.PRECISION_F NPRECISION_F,
                     T.STATUS      NSTATUS,
                     T.ERR         SERR
                from UDO_T_EQUIPDSCMML T
               where T.PRN = NEQUIPDSCM
               order by T.RN)
    loop
      /*     */
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NRN', NVALUE => C.NRN, BCLEAR => true);
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'STASK', SVALUE => C.STASK);
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NPRECISION_P', NVALUE => C.NPRECISION_P);
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NPRECISION_F', NVALUE => C.NPRECISION_F);
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NSTATUS', NVALUE => C.NSTATUS);
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SERR', SVALUE => C.SERR);
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SACTIONS');
      /*     */
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW);
    end loop;
    /*   */
    COUT := PKG_P8PANELS_VISUAL.TDATA_GRID_TO_XML(RDATA_GRID => RDG, NINCLUDE_DEF => 1);
  end CMML_LIST;
  
  /*   "   ( , )" */
  procedure CMML_INS
  (
    NPRN                    in number,   -- 
    STASK                   in varchar2, --  (TCF -    (Technical Condition Forecast), RUL -    (Remaining Useful Life), FP -   (Failure Predict))
    NPRECISION_P            in number,   --  ()
    NRN                     out number   --  
  )
  is
  begin
    /*   */
    UDO_PKG_EQUIPDS_BASE.CMML_INS(NPRN => NPRN, STASK => STASK, NPRECISION_P => NPRECISION_P, NRN => NRN);
  end CMML_INS;

  /*   "   ( , )" */
  procedure CMML_DEL
  (
    NRN                     in number   --  
  )
  is
  begin
    /*   */
    UDO_PKG_EQUIPDS_BASE.CMML_DEL(NRN => NRN);
  end CMML_DEL;  
  
  /*    "   ( , )" */
  procedure CMML_SEND_RQ
  (
    NEQUIPDSCMML            in number   -- .      
  )
  is
  begin
    /*
    TODO: owner="root" created="07.08.2024"
    text="       "
    */
    /*    */
    for C in (select T.RN          NRN,
                     T.PRECISION_P NPRECISION_P
                from UDO_T_EQUIPDSCMML T
               where T.RN = NEQUIPDSCMML)
    loop
      /*    */
      UDO_PKG_EQUIPDS_BASE.CMML_SET_PRECISION_F(NRN => C.NRN, NPRECISION_F => C.NPRECISION_P);
      /*    */
      UDO_PKG_EQUIPDS_BASE.CMML_SET_STATUS(NRN => C.NRN, NSTATUS => 2, SQUEUE_ID => C.NRN, SERR => null);
    end loop;
  end CMML_SEND_RQ;
  
  /*  "   ( , )"    */
  function CMML_STATUS_BY_EQCONFIG
  (
    NEQCONFIG               in number        -- .    
  ) return                  number           --     (0 -  , 1 -     , 2 -   )
  is
    NRES                    PKG_STD.TNUMBER; --   
  begin
    /*   -   */
    NRES := 0;
    /*   */
    for C in (select ML.STATUS
                from UDO_T_EQUIPDSCM   CM,
                     UDO_T_EQUIPDSCMML ML
               where CM.EQOBJKIND = (select CF.OBJ_KIND from EQCONFIG CF where CF.RN = NEQCONFIG)
                 and CM.RN = ML.PRN)
    loop
      /*   */
      NRES := 1;
      /*     */
      if (C.STATUS = 2) then
        NRES := 2;
      end if;
    end loop;
    /*   */
    return NRES;
  end CMML_STATUS_BY_EQCONFIG;

  /*  "   ( , )"    */
  procedure CMML_LIST_BY_EQCONFIG
  (
    NEQCONFIG               in number,                      -- .    
    COUT                    out clob                        --   
  )
  is
    RDG                     PKG_P8PANELS_VISUAL.TDATA_GRID; --  
    RDG_ROW                 PKG_P8PANELS_VISUAL.TROW;       --  
  begin
    /*    */
    RDG := PKG_P8PANELS_VISUAL.TDATA_GRID_MAKE();
    /*      */
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NRN',
                                               SCAPTION   => '.  ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NEQUIPDS',
                                               SCAPTION   => '.  ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NEQUIPDSCM',
                                               SCAPTION   => '.    ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SNEQUIPDS',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'STASK',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               SHINT      => '  :<br>' ||
                                                             UDO_PKG_EQUIPDS_BASE.CMML_TASK_HINT());
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NPRECISION_P',
                                               SCAPTION   => ' ()',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NPRECISION_F',
                                               SCAPTION   => ' ()',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NSTATUS',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SERR',
                                               SCAPTION   => '  ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SACTIONS',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR);
    /*   */
    for C in (select T.RN          NRN,
                     CM.PRN        NEQUIPDS,
                     T.PRN         NEQUIPDSCM,
                     DS.NAME       SNEQUIPDS,
                     T.TASK        STASK,
                     T.PRECISION_P NPRECISION_P,
                     T.PRECISION_F NPRECISION_F,
                     T.STATUS      NSTATUS,
                     T.ERR         SERR
                from UDO_T_EQUIPDSCMML T,
                     UDO_T_EQUIPDSCM   CM,
                     UDO_T_EQUIPDS     DS
               where T.PRN = CM.RN
                 and CM.PRN = DS.RN
                 and CM.EQOBJKIND = (select CF.OBJ_KIND from EQCONFIG CF where CF.RN = NEQCONFIG)
               order by T.RN)
    loop
      /*     */
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NRN', NVALUE => C.NRN, BCLEAR => true);
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NEQUIPDS', NVALUE => C.NEQUIPDS);
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NEQUIPDSCM', NVALUE => C.NEQUIPDSCM);
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SNEQUIPDS', SVALUE => C.SNEQUIPDS);
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'STASK', SVALUE => C.STASK);
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NPRECISION_P', NVALUE => C.NPRECISION_P);
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NPRECISION_F', NVALUE => C.NPRECISION_F);
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NSTATUS', NVALUE => C.NSTATUS);
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SERR', SVALUE => C.SERR);
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SACTIONS');
      /*     */
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW);
    end loop;
    /*   */
    COUT := PKG_P8PANELS_VISUAL.TDATA_GRID_TO_XML(RDATA_GRID => RDG, NINCLUDE_DEF => 1);
  end CMML_LIST_BY_EQCONFIG;
  
  /*  - */
  procedure CMMLH_DEMO_BUILD
  (
    STASK                   in varchar2,                        -- 
    COUT                    out clob                            --  -
  )
  is
    RCH                     PKG_P8PANELS_VISUAL.TCHART;         -- 
    RCH_DS                  PKG_P8PANELS_VISUAL.TCHART_DATASET; --  
    DMONTH                  date;                               --  
  begin
    /*    */
    RCH := PKG_P8PANELS_VISUAL.TCHART_MAKE(STYPE     => PKG_P8PANELS_VISUAL.SCHART_TYPE_LINE,
                                           STITLE    => '  5 ',
                                           SLGND_POS => PKG_P8PANELS_VISUAL.SCHART_LGND_POS_RIGHT);
    /*    */
    RCH_DS := PKG_P8PANELS_VISUAL.TCHART_DATASET_MAKE(SCAPTION => STASK);
    /*    */
    for I in 1 .. 5
    loop
      /*     */
      DMONTH := ADD_MONTHS(sysdate, I);
      PKG_P8PANELS_VISUAL.TCHART_ADD_LABEL(RCHART => RCH,
                                           SLABEL => F_GET_MONTH(NVALUE => EXTRACT(month from DMONTH)) || ' ' ||
                                                     TO_CHAR(DMONTH, 'yyyy'));
      /*      */
      PKG_P8PANELS_VISUAL.TCHART_DATASET_ADD_ITEM(RDATASET => RCH_DS, NVALUE => ROUND(DBMS_RANDOM.VALUE(1, 100)));
    end loop;
    /*      */
    PKG_P8PANELS_VISUAL.TCHART_ADD_DATASET(RCHART => RCH, RDATASET => RCH_DS);
    /*   */
    COUT := PKG_P8PANELS_VISUAL.TCHART_TO_XML(RCHART => RCH, NINCLUDE_DEF => 1);
  end CMMLH_DEMO_BUILD;
  
  /*    - */
  function CMMLH_DEMO_FORECAST_PARSE
  (
    CFORECAST               in clob              --  -
  ) return                  number               --  
  is
    XDOC                    PKG_XPATH.TDOCUMENT; --  -
    XROOT                   PKG_XPATH.TNODE;     --   
  begin
    /*  - */
    XDOC := PKG_XPATH.PARSE_FROM_CLOB(LCXML => CFORECAST);
    /*    */
    XROOT := PKG_XPATH.ROOT_NODE(RDOCUMENT => XDOC);
    /*      */
    return PKG_XPATH.VALUE_NUM(RNODE => PKG_XPATH.SINGLE_NODE(RPARENT_NODE => XROOT,
                                                              SPATTERN     => 'XDATA/XCHART/datasets/data'));
  exception
    when others then
      return null;
  end CMMLH_DEMO_FORECAST_PARSE;
  
  /*  "   ( , ,  )"    */
  procedure CMMLH_LIST_BY_EQCONFIG
  (
    NEQCONFIG               in number,                      -- .    
    COUT                    out clob                        --   
  )
  is
    RDG                     PKG_P8PANELS_VISUAL.TDATA_GRID; --  
    RDG_ROW                 PKG_P8PANELS_VISUAL.TROW;       --  
  begin
    /*    */
    RDG := PKG_P8PANELS_VISUAL.TDATA_GRID_MAKE();
    /*      */
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NRN',
                                               SCAPTION   => '. ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SRQ_AUTHID',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SRQ_DATE',
                                               SCAPTION   => '/ ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SEQUIPDS_CODE',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SEQUIPDSCMML_TASK',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               SHINT      => UDO_PKG_EQUIPDS_BASE.CMML_TASK_HINT());
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NEQUIPDSCMML_PRECISION_F',
                                               SCAPTION   => ' ()',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NFORECAST',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               SHINT      => '<b style="color:red"></b> -    60%.<br>' ||
                                                             '<b style="color:orange"></b> -    30%  60%<br>' ||
                                                             '<b style="color:green"> </b> -    30%');
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SFORECAST',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    /*   */
    for C in (select T.RN NRN,
                     T.RQ_AUTHID SRQ_AUTHID,
                     TO_CHAR(T.RQ_DATE, 'dd.mm.yyyy hh24:mi:ss') SRQ_DATE,
                     DS.CODE SEQUIPDS_CODE,
                     ML.TASK SEQUIPDSCMML_TASK,
                     ML.PRECISION_F NEQUIPDSCMML_PRECISION_F,
                     null NFORECAST,
                     null SFORECAST,
                     T.FORECAST BFORECAST
                from UDO_T_EQUIPDSCMMLH T,
                     UDO_T_EQUIPDSCMML  ML,
                     UDO_T_EQUIPDSCM    CM,
                     UDO_T_EQUIPDS      DS
               where T.EQCONFIG = NEQCONFIG
                 and T.PRN = ML.RN
                 and ML.PRN = CM.RN
                 and CM.PRN = DS.RN
               order by T.RN desc)
    loop
      /*    */
      C.SFORECAST := BLOB2CLOB(LBDATA => C.BFORECAST);
      /*   */
      C.NFORECAST := CMMLH_DEMO_FORECAST_PARSE(CFORECAST => C.SFORECAST);
      /*     */
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NRN', NVALUE => C.NRN, BCLEAR => true);
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SRQ_AUTHID', SVALUE => C.SRQ_AUTHID);
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SRQ_DATE', SVALUE => C.SRQ_DATE);
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SEQUIPDS_CODE', SVALUE => C.SEQUIPDS_CODE);
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SEQUIPDSCMML_TASK', SVALUE => C.SEQUIPDSCMML_TASK);
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW   => RDG_ROW,
                                       SNAME  => 'NEQUIPDSCMML_PRECISION_F',
                                       NVALUE => C.NEQUIPDSCMML_PRECISION_F);
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NFORECAST', NVALUE => C.NFORECAST);
      PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SFORECAST', SVALUE => C.SFORECAST);
      /*     */
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW);
    end loop;
    /*   */
    COUT := PKG_P8PANELS_VISUAL.TDATA_GRID_TO_XML(RDATA_GRID => RDG, NINCLUDE_DEF => 1);
  end CMMLH_LIST_BY_EQCONFIG;
  
end UDO_PKG_EQUIPDS;
/
